image: docker:18.09

services:
  - docker:18.09-dind


before_script:
  - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY


stages:
  - build
  - push

Build:
  stage: build
  script: 
    - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  only:
    - master

Push:
  variables:
    GIT_STRATEGY: none
  stage: push
  script:
    - docker pull $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - >
      if [ "$CI_COMMIT_REF_NAME" == "master" ]; then
        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $CI_REGISTRY_IMAGE:latest && 
        docker push $CI_REGISTRY_IMAGE:latest
      else
        docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME && 
        docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
      fi
